%{
/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "ypp.h"
#include "y.tab.h"
%}

id	[a-zA-Z0-9\_]+

%%

\n			;

"/*"		skipcmnts();

\"[^\"\n]+\" {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return(STRING);
}

{id}"-list" {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return(KLIST);
}

^{id} {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return(C_IDENTIFIER);
}

{id} {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return(IDENTIFIER);
}

"'"[^\'\n]+"'" {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext);
	return(L_IDENTIFIER);
}

[0-9]+		{return(NUMBER);}

"%left"		{return(LEFT);}
"%right"	{return(RIGHT);}
"%nonassoc"	{return(NONASSOC);}
"%token"	{return(TOKEN);}
"%prec"		{return(PREC);}
"%type"		{return(TYPE);}
"%start"	{return(START);}
"%union"	{return(UNION);}

"%%"		{return(MARK);}
"%{"		{return(LCURL);}

"<"			{return('<');}
">"			{return('>');}
","			{return(',');}
"|"			{return('|');}
"{"			{return('{');}
"}"			{return('}');}
";"			{return(';');}
"["			{return('[');}
"]"			{return(']');}

"A|"[^|\]]+/[|\]] {
	yylval.str = (char*) U_malloc (strlen (yytext) + 1);
	strcpy (yylval.str, yytext+2);
	return (EASTRING);
}

"D|" {
	return (EDSTRING);
}

"N|" {  /* forces that node to be a real node in the tree */
	return (ENSTRING);
}

"O|"	return (EOSTRING);

"NP|" {  /* no rule is produced for this action, but *_auto.h files produced */
	return (ENPSTRING);
}

.			;

%%
copy_file()
{
	int c;

	while ((c = input()) != 0)
		putchar (c);
}

char *get_act()
{
	int i, c, bcount = 0;
/*	char buf[2048], *act;*/
	char buf[4096], *act;

	i = 0;
	while ((c = input()) != '}' || bcount)
	{
		if (i > 4096)
			fatal ("get_act: increase buffer size");
		buf[i++] = c;
		if (c == '{')
			bcount++;
		else if (c == '}')
			bcount--;
	}
	unput(c);

	buf[i] = '\0';
	act = (char*) U_malloc (i + 1);
	strcpy (act, buf);

	return act;
}

p_LCURL()
{
	int c,d, bcount = 0;

	printf ("\n%%{");
	while ((c = input()) != '}' || bcount)
	{
		if (c == '{')
			bcount++;
		else if (c == '}')
			bcount--;

		putchar (c);
	}
	printf ("}\n\n");
}

p_UNION()
{
	int c,d, bcount = (-1);

	while ((c = input()) != '}' || bcount)
	{
		if (c == '{')
			bcount++;
		else if (c == '}')
			bcount--;

		putchar (c);
	}
}

skipcmnts()
{
	int c;

	for (;;)
	{
		while (input() != '*')
			;
		if ((c = input()) != '/')
		{
			unput(c);
		}
		else
			return;
	}
}
